\section{Major differences}
\subsection{Major differences}


\begin{frame}[label={sec:major-diff}]{Major differences}
%------------------------------------------ diapo -----------------------------------------------

Major differences between Gitab-CI, Github Action, Jenkins in Inria context:

\begin{itemize}
    \item Configuration strategies
    \item Result presentation strategies
    \item Runner offering and configuration strategies
\end{itemize}

%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:diff-configuration-strategie-gitlab}]{Configuration strategies differences 1/3}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Gitlab}

Single pipeline configuration file entry point hosted on the source git repository.

Major services are proposed via language concepts (ex: archive, report).

Each pipeline job is executed on a dedicated/separate runner.

Default job structure in phases.

Pro:
\begin{itemize}
    \item Easy maintenance (some security upgrade are done by gitlab administrators)
    \item Easy setup of multibranch pipelines
\end{itemize}
Cons: (Ie. situation where configuration isn't straightforward)
\begin{itemize}
    \item Build using resource from multiple repositories (Typically, integration testing of large projects)
    \item Organization of the tasks may be more complex depending on trigger rules
    \item Passing large amount of data between jobs may be an issue
\end{itemize}


\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:diff-configuration-strategie-github}]{Configuration strategies differences 2/3}
%------------------------------------------ diapo -----------------------------------------------

\begin{block}{Github}

Multiple pipeline configuration files entry point hosted on the source git repository.

Major services are proposed via a marketplace.

Each pipeline job is executed on a dedicated/separate runner.

Pro:
\begin{itemize}
    \item Easy maintenance (some security upgrade are done by github)
    \item Easy setup of multibranch pipelines
    \item Easy first stage trigger configuration
\end{itemize}
Cons: (Ie. situation where configuration isn't straightforward)
\begin{itemize}
    \item Build using resource from multiple repositories (Typically, integration testing of large projects)
    \item Passing large amount of data between jobs may be an issue
    \item Many useful features aren't provided by official companies
\end{itemize}

\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:diff-configuration-strategie-jenkins}]{Configuration strategies differences 3/3}
%------------------------------------------ diapo -----------------------------------------------

\begin{block}{Jenkins}

Multiple pipeline configuration files entry point hosted on any repository or on the Jenkins server.

Major services are proposed via plugins.

Possibility to create stages within a job.

Pro:
\begin{itemize}
    \item Must choose between: Easy build based on several repositories
    or Easy setup of multibranch pipelines
    \item Easy aggregation of pipelines from several repository
\end{itemize}
Cons: (Ie. situation where configuration isn't straightforward)
\begin{itemize}
    \item CI server maintenance may cause issue (upgrade)
    \item Better integration with the forge (Job triggering on push, on merge request) requires dedicated plugin.
\end{itemize}

\end{block}


%------------------------------------------------------------------------------------------------
\end{frame}

\newcommand{\diffResultsDisplayTitle}{Result presentation strategies differences\xspace}
\begin{frame}[label={sec:diff-presentation-strategie}]{\diffResultsDisplayTitle}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Several dimensions}

\begin{itemize}

\item Temporal aspects
\begin{itemize}
    \item One-off report
    \item Historical perspective / regression detection
\end{itemize}
\item Report diversity support
\begin{itemize}
    \item junit XML files
    \item coverage report
    \item \dots
\end{itemize}
\item Report display page
\begin{itemize}
    \item ad'hoc visualization
    \item predefined visualization (e.g. general dashboard, upon pull requests \dots)
\end{itemize}

\end{itemize}

\end{block}
\end{frame}

\begin{frame}[label={sec:diff-presentation-strategie-gitlab}]{\diffResultsDisplayTitle 1/3}
\begin{block}{GitlabCI}



Pro:
\begin{itemize}
    \item Build results are presented directly in the forge.
    \item Support for various reports formats: \footnote[frame]{\href{https://docs.gitlab.com/ee/ci/yaml/artifacts_reports.html}{https://docs.gitlab.com/ee/ci/yaml/artifacts\_reports.html}}
    
    \item Convenient integration in the developer process UI (Merge Request)
\end{itemize}
Cons: (Ie. situation where configuration isn't straightforward)
\begin{itemize}
    \item Limited support for test result presentation (no customizable views)
    \item No integrated support for regression testing (except coverage)
    \item No integrated support for continuous performance testing
\end{itemize}

\end{block}
\end{frame}

\begin{frame}[label={sec:diff-presentation-strategie-github}]{\diffResultsDisplayTitle 2/3}
\begin{block}{GithubAction}

Pipeline are run stateless.


Pro:
\begin{itemize}
    \item Build results are presented directly in the forge.
\end{itemize}
Cons: (Ie. situation where configuration isn't straightforward)
\begin{itemize}
    \item Limited support for test result presentation (no customizable views)
    \item 
\end{itemize}
\end{block}


\end{frame}

\begin{frame}[label={sec:diff-presentation-strategie-jenkins}]{\diffResultsDisplayTitle 3/3}

\begin{block}{Jenkins}

Pro:
\begin{itemize}
    \item Good test result presentation including test trend
\end{itemize}
Cons: (Ie. situation where configuration isn't straightforward)
\begin{itemize}
    \item Build result not directly presented in the forge (can be configured by using a plugin \footnote[frame]{ \href{https://plugins.jenkins.io/github/}{https://plugins.jenkins.io/github/} and  \href{https://applitools.com/blog/how-to-update-jenkins-build-status-in-github-pull-requests-step-by-step-tutorial/}{https://applitools.com/blog/how-to-update-jenkins-build-status-in-github-pull-requests-step-by-step-tutorial/}})
\end{itemize}
\end{block}
\end{frame}

%------------------------------------------------------------------------------------------------
\begin{frame}[label={sec:diff-runner-strategie}]{Runner strategies differences}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{TODO -> ERIC lieu où remonter}


(à affiner en fonction de notre offre)



\end{block}



%------------------------------------------------------------------------------------------------
\end{frame}
